	.area text(rom,rel)
	.dbfile ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\stack.c
	.dbfile C:\ICCPRO~1\nanovm\vm\src\stack.c
	.dbfunc e stack_init _stack_init fV
;  static_fields -> R4
_stack_init::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 62
; //
; //  NanoVM, a tiny java VM for the Atmel AVR family
; //  Copyright (C) 2005 by Till Harbaum <Till@Harbaum.org>
; //
; //  This program is free software; you can redistribute it and/or modify
; //  it under the terms of the GNU General Public License as published by
; //  the Free Software Foundation; either version 2 of the License, or
; //  (at your option) any later version.
; //
; //  This program is distributed in the hope that it will be useful,
; //  but WITHOUT ANY WARRANTY; without even the implied warranty of
; //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; //  GNU General Public License for more details.
; //
; //  You should have received a copy of the GNU General Public License
; //  along with this program; if not, write to the Free Software
; //  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
; //
; 
; //
; //  stack.c
; //
; 
; #include "types.h"
; #include "debug.h"
; #include "config.h"
; #include "error.h"
; 
; #include "vm.h"
; #include "heap.h"
; #include "stack.h"
; 
; // the stack
; static nvm_stack_t *stack;     // the pysical base of the whole stack (incl. statics)
; static nvm_stack_t *sp;        // the current stack pointer
; static nvm_stack_t *stackbase; // the base of the runtime stack (excl. statics)
; 
; #ifdef NVM_USE_STACK_CHECK
; nvm_stack_t *sp_saved = NULL;
; 
; // save current stack pointer
; void stack_save_sp(void) {
;   if(sp_saved != NULL) {
;     DEBUGF("sp_saved already in use\n");
;     error(ERROR_VM_STACK_CORRUPTED);
;   }
; 
;   sp_saved = sp;  // save stack pointer
; }
; 
; // check if current stack pointer equals saved one
; void stack_verify_sp(void) {
;   if(sp != sp_saved) {
;     DEBUGF("%d bytes on stack\n", sp-sp_saved);
;     error(ERROR_VM_STACK_CORRUPTED);
;   }
; 
;   sp_saved = NULL;
; }
; #endif
; 
; void stack_init(u08_t static_fields) {
	.dbline 67
; 
;   // the stack is generated by stealing from the heap. This
;   // is possible since the class file tells us how many stack
;   // elements the call to a method requires
;   stack = (nvm_stack_t*)heap_get_base();
	@FCALL	
	.long _heap_get_base	
	mov R15,R0	
	@FSTOREL	
	.long _stack	
	.long R15	
	.dbline 68
;   sp = stack-1;
	@FLDCNST	
	.long -2	
	mov R15,TEMP0	
	@FLOADL	
	.long _stack	
	.long R14	
	add R14,R15	
	@FSTOREL	
	.long _sp	
	.long R14	
	.dbline 72
; 
;   // steal one item for mains args and the space required for 
;   // the static fields
;   heap_steal((1+static_fields)*sizeof(nvm_stack_t)); 
	mov R15,R4	
	and R15,MASKFF	
	add R15,#1	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	and R0,MASKFFFF	
	@FCALL	
	.long _heap_steal	
	.dbline 75
; 
;   // increase stack pointer behind static fields
;   sp += static_fields;
	mov R15,R4	
	and R15,MASKFF	
	mov R14,#2	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FLOADL	
	.long _sp	
	.long R14	
	mov R15,R15	
	add R15,R14	
	@FSTOREL	
	.long _sp	
	.long R15	
	.dbline -2
L5:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r static_fields 4 c
	.dbend
	.dbfunc e stack_push _stack_push fV
;            val -> R0
_stack_push::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 79
; }
; 
; // push an item onto the vms stack
; void stack_push(nvm_stack_t val) {
	.dbline 80
;   *(++sp) = val;
	@FLOADL	
	.long _sp	
	.long R15	
	mov R15,R15	
	add R15,#2	
	mov R15,R15	
	@FSTOREL	
	.long _sp	
	.long R15	
	wrword R0,R15	
	.dbline -2
L6:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r val 0 s
	.dbend
	.dbfunc e stack_pop _stack_pop fs
_stack_pop::
	@FENTER	
	.long R13,R14,R15,0	
	.dbline -1
	.dbline 84
; }
; 
; // pop an item from the vms stack
; nvm_stack_t stack_pop(void) {
	.dbline 85
;   return *(sp--);
	@FLOADL	
	.long _sp	
	.long R15	
	mov R15,R15	
	@FLDCNST	
	.long -2	
	mov R14,TEMP0	
	mov R13,R15	
	add R13,R14	
	@FSTOREL	
	.long _sp	
	.long R13	
	rdword R0,R15	
	and R0,MASKFFFF	
	.dbline -2
L7:
	@FPOP	
	.long R15,R14,R13,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e stack_pop_int _stack_pop_int fS
_stack_pop_int::
	@FENTER	
	.long R13,R14,R15,0	
	.dbline -1
	.dbline 89
; }
; 
; // pop an item from the vm stack
; nvm_int_t stack_pop_int(void) {
	.dbline 90
;   return nvm_stack2int(*(sp--));
	@FLOADL	
	.long _sp	
	.long R15	
	mov R15,R15	
	@FLDCNST	
	.long -2	
	mov R14,TEMP0	
	mov R13,R15	
	add R13,R14	
	@FSTOREL	
	.long _sp	
	.long R13	
	rdword R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _nvm_stack2int	
	mov R15,R0	
	mov R0,R15	
	shl R0,#16	
	sar R0,#16	
	.dbline -2
L8:
	@FPOP	
	.long R15,R14,R13,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e stack_peek _stack_peek fs
;          index -> R4
_stack_peek::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 94
; }
; 
; // peek into the nvm stack
; nvm_stack_t stack_peek(u08_t index) {
	.dbline 95
;   return sp[-index];
	mov R15,R4	
	and R15,MASKFF	
	neg R15,R15	
	mov R14,#2	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FLOADL	
	.long _sp	
	.long R14	
	mov R15,R15	
	add R15,R14	
	rdword R0,R15	
	and R0,MASKFFFF	
	.dbline -2
L9:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r index 4 c
	.dbend
	.dbfunc e stack_peek_int _stack_peek_int fS
;          index -> R4
_stack_peek_int::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 99
; }
; 
; // peek into the stack and expand 15->16 bits
; nvm_int_t stack_peek_int(u08_t index) {
	.dbline 100
;   return nvm_stack2int(sp[-index]);
	mov R15,R4	
	and R15,MASKFF	
	neg R15,R15	
	mov R14,#2	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FLOADL	
	.long _sp	
	.long R14	
	mov R15,R15	
	add R15,R14	
	rdword R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _nvm_stack2int	
	mov R15,R0	
	mov R0,R15	
	shl R0,#16	
	sar R0,#16	
	.dbline -2
L10:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r index 4 c
	.dbend
	.dbfunc e stack_pop_addr _stack_pop_addr fpV
_stack_pop_addr::
	@FENTER	
	.long R13,R14,R15,0	
	.dbline -1
	.dbline 104
; }
; 
; // pop address from stack
; void *stack_pop_addr(void) {
	.dbline 105
;   return vm_get_addr(*(sp--));
	@FLOADL	
	.long _sp	
	.long R15	
	mov R15,R15	
	@FLDCNST	
	.long -2	
	mov R14,TEMP0	
	mov R13,R15	
	add R13,R14	
	@FSTOREL	
	.long _sp	
	.long R13	
	rdword R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _vm_get_addr	
	mov R15,R0	
	.dbline -2
L11:
	@FPOP	
	.long R15,R14,R13,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e stack_peek_addr _stack_peek_addr fpV
;          index -> R4
_stack_peek_addr::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 109
; }
; 
; // peek into the nvm stack for address
; void *stack_peek_addr(u08_t index) {
	.dbline 110
;   return vm_get_addr(sp[-index]);
	mov R15,R4	
	and R15,MASKFF	
	neg R15,R15	
	mov R14,#2	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FLOADL	
	.long _sp	
	.long R14	
	mov R15,R15	
	add R15,R14	
	rdword R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _vm_get_addr	
	mov R15,R0	
	.dbline -2
L12:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r index 4 c
	.dbend
	.dbfunc e stack_add_sp _stack_add_sp fV
;         offset -> R4
_stack_add_sp::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 129
; }
; 
; # ifdef NVM_USE_FLOAT
; nvm_float_t stack_pop_float(void)
; {
;   return nvm_stack2float(*(sp--));
; }
; 
; nvm_float_t stack_peek_float(u08_t index)
; {
;   return nvm_stack2float(sp[-index]);
; }
; #endif
; 
; // the following two routines are used during method invocation and return
; // they are used to make space for local variables on the stack
; // and to determine the current stack address to be used for the local
; // variables
; void stack_add_sp(s08_t offset) {
	.dbline 130
;   sp += offset;
	mov R15,R4	
	shl R15,#24	
	sar R15,#24	
	mov R14,#2	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FLOADL	
	.long _sp	
	.long R14	
	mov R15,R15	
	add R15,R14	
	@FSTOREL	
	.long _sp	
	.long R15	
	.dbline -2
L13:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r offset 4 C
	.dbend
	.dbfunc e stack_get_sp _stack_get_sp fps
_stack_get_sp::
	.dbline -1
	.dbline 133
; }
; 
; nvm_stack_t * stack_get_sp(void) {
	.dbline 134
;   return sp;
	@FLOADL	
	.long _sp	
	.long R0	
	.dbline -2
L14:
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e stack_get_static _stack_get_static fs
;          index -> R4
_stack_get_static::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 139
; }
; 
; // static variables are allocated at vm startup on the stack. the following
; // two routines provide access to these variables
; nvm_stack_t stack_get_static(u16_t index) {
	.dbline 140
;   return stack[index];
	mov R15,R4	
	and R15,MASKFFFF	
	mov R14,#2	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FLOADL	
	.long _stack	
	.long R14	
	mov R15,R15	
	add R15,R14	
	rdword R0,R15	
	and R0,MASKFFFF	
	.dbline -2
L15:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r index 4 s
	.dbend
	.dbfunc e stack_set_static _stack_set_static fV
;          value -> R4
;          index -> R5
_stack_set_static::
	@FENTER	
	.long R4,R5,R14,R15,0	
	mov R5,R0	
	mov R4,R1	
	.dbline -1
	.dbline 143
; }
; 
; void stack_set_static(u16_t index, nvm_stack_t value) {
	.dbline 144
;   stack[index] = value;
	mov R15,R5	
	and R15,MASKFFFF	
	mov R14,#2	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FLOADL	
	.long _stack	
	.long R14	
	mov R15,R15	
	add R15,R14	
	wrword R4,R15	
	.dbline -2
L16:
	@FPOP	
	.long R15,R14,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r value 4 s
	.dbsym r index 5 s
	.dbend
	.dbfunc e stack_save_base _stack_save_base fV
_stack_save_base::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 154
; }
; 
; // our way to determine if the java application is being
; // finished is to check if the return instruction would cause the
; // stack to underflow. this happens, since the main method ends
; // with a return statement like any other method. the following
; // two methods are used to save the state of the empty stack (there
; // may be already the static variables be on the stack) and to check
; // whether the stack is filled with the static variables only (it is empty)
; void stack_save_base(void) {
	.dbline 155
;   stackbase = stack_get_sp();
	@FCALL	
	.long _stack_get_sp	
	mov R15,R0	
	@FSTOREL	
	.long _stackbase	
	.long R15	
	.dbline -2
L17:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e stack_is_empty _stack_is_empty fc
_stack_is_empty::
	@FENTER	
	.long R14,R15,0	
	.dbline -1
	.dbline 158
; }
; 
; bool_t stack_is_empty(void) {
	.dbline 159
;   DEBUGF("stack base depth: %d\n", sp-stackbase);
	.dbline 160
;   return(sp == stackbase);
	@FLOADL	
	.long _stackbase	
	.long R15	
	@FLOADL	
	.long _sp	
	.long R14	
	cmp R14,R15	WZ
IF_NE	add PC,#8	;Jump to L20
	mov R1,#1	
	add PC,#4	;Jump to L21
L20:
	mov R1,#0	
L21:
	mov R0,R1	
	and R0,MASKFF	
	.dbline -2
L18:
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e stack_heap_id_in_use _stack_heap_id_in_use fc
;           id16 -> R5
;              i -> R4
;             id -> R4
_stack_heap_id_in_use::
	@FENTER	
	.long R4,R5,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 169
; }
; 
; #ifdef DEBUG
; u16_t stack_get_depth(void) {
;   return sp-stack;
; }
; #endif
; 
; bool_t stack_heap_id_in_use(heap_id_t id) {
	.dbline 172
;   // we are searching for heap objects only
;   u16_t i;
;   nvm_ref_t id16 = id | NVM_TYPE_HEAP;
	@FLDCNST	
	.long 32768	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFF	
	or R14,R15	
	mov R5,R14	
	.dbline 176
; 
;   // since the locals are physically part of the stack we only need
;   // to search the stack
;   for(i=0;i<sp-stack+1;i++) {
	mov R4,#0	
	add PC,#96	;Jump to L26
L23:
	.dbline 176
	.dbline 178
; //    DEBUGF("Stack %d == "DBG16"\n", i, stack[i]);
;     if(stack[i] == id16) return TRUE;
	mov R15,R4	
	and R15,MASKFFFF	
	mov R14,#2	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FLOADL	
	.long _stack	
	.long R14	
	mov R15,R15	
	add R15,R14	
	rdword R15,R15	
	and R15,MASKFFFF	
	mov R14,R5	
	and R14,MASKFFFF	
	cmp R15,R14	WZ
IF_NE	add PC,#8	;Jump to L27
	.dbline 178
	mov R0,#1	
	add PC,#76	;Jump to L22
L27:
	.dbline 179
;   }
L24:
	.dbline 176
	mov R15,R4	
	and R15,MASKFFFF	
	add R15,#1	
	mov R4,R15	
L26:
	.dbline 176
	@FLOADL	
	.long _stack	
	.long R15	
	@FLOADL	
	.long _sp	
	.long R14	
	sub R14,R15	
	mov R15,R14	
	shr R15,#1	
	add R15,#1	
	mov R14,R4	
	and R14,MASKFFFF	
	cmp R14,R15	WC
IF_B	sub PC,#152	;Jump to L23
	.dbline 181
; 
;   return FALSE;
	mov R0,#0	
	.dbline -2
L22:
	@FPOP	
	.long R15,R14,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r id16 5 s
	.dbsym r i 4 s
	.dbsym r id 4 c
	.dbend
	.area bss(ram,rel)
	.dbfile C:\ICCPRO~1\nanovm\vm\src\stack.c
	.align	4
_stackbase:
	.blkb 4
	.dbsym s stackbase _stackbase ps
	.align	4
_sp:
	.blkb 4
	.dbsym s sp _sp ps
	.align	4
_stack:
	.blkb 4
	.dbsym s stack _stack ps
